Index: gcc/testsuite/gcc.target/arm/armv8-sync-op-acquire.c
===================================================================
--- gcc/testsuite/gcc.target/arm/armv8-sync-op-acquire.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/arm/armv8-sync-op-acquire.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,10 @@
+/* { dg-do compile } */
+/* { dg-require-effective-target arm_arch_v8a_ok } */
+/* { dg-options "-O2" } */
+/* { dg-add-options arm_arch_v8a } */
+
+#include "../aarch64/sync-op-acquire.x"
+
+/* { dg-final { scan-assembler-times "ldrex" 1 } } */
+/* { dg-final { scan-assembler-times "strex" 1 } } */
+/* { dg-final { scan-assembler-times "dmb" 1 } } */
Index: gcc/testsuite/gcc.target/arm/macro_defs0.c
===================================================================
--- gcc/testsuite/gcc.target/arm/macro_defs0.c	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ gcc/testsuite/gcc.target/arm/macro_defs0.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -1,6 +1,7 @@
 /* { dg-do compile } */
 /* { dg-skip-if "avoid conflicting multilib options" { *-*-* } { "-march=*" } { "-march=armv7-m" } } */
 /* { dg-skip-if "avoid conflicting multilib options" { *-*-* } { "-mfloat-abi=*" } { "-mfloat-abi=soft" } } */
+/* { dg-skip-if "avoid conflicting multilib options" { *-*-* } { "-marm" } { "" } } */
 /* { dg-options "-march=armv7-m -mcpu=cortex-m3 -mfloat-abi=soft -mthumb" } */
 
 #ifdef __ARM_FP
Index: gcc/testsuite/gcc.target/arm/armv8-sync-op-full.c
===================================================================
--- gcc/testsuite/gcc.target/arm/armv8-sync-op-full.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/arm/armv8-sync-op-full.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,10 @@
+/* { dg-do compile } */
+/* { dg-require-effective-target arm_arch_v8a_ok } */
+/* { dg-options "-O2" } */
+/* { dg-add-options arm_arch_v8a } */
+
+#include "../aarch64/sync-op-full.x"
+
+/* { dg-final { scan-assembler-times "ldrex" 12 } } */
+/* { dg-final { scan-assembler-times "stlex" 12 } } */
+/* { dg-final { scan-assembler-times "dmb" 12 } } */
Index: gcc/testsuite/gcc.target/arm/vnmul-4.c
===================================================================
--- gcc/testsuite/gcc.target/arm/vnmul-4.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/arm/vnmul-4.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,18 @@
+/* { dg-do compile } */
+/* { dg-require-effective-target arm_vfp_ok } */
+/* { dg-skip-if "need fp instructions" { *-*-* } { "-mfloat-abi=soft" } { "" } } */
+/* { dg-options "-O2 -frounding-math -mfpu=vfp -mfloat-abi=hard" } */
+
+double
+foo_d (double a, double b)
+{
+  /* { dg-final { scan-assembler "vnmul\\.f64" } } */
+  return -(a * b);
+}
+
+float
+foo_s (float a, float b)
+{
+  /* { dg-final { scan-assembler "vnmul\\.f32" } } */
+  return -(a * b);
+}
Index: gcc/testsuite/gcc.target/arm/macro_defs1.c
===================================================================
--- gcc/testsuite/gcc.target/arm/macro_defs1.c	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ gcc/testsuite/gcc.target/arm/macro_defs1.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -1,5 +1,6 @@
 /* { dg-do compile } */
 /* { dg-skip-if "avoid conflicting multilib options" { *-*-* } { "-march=*" } { "-march=armv6-m" } } */
+/* { dg-skip-if "avoid conflicting multilib options" { *-*-* } { "-marm" } { "" } } */
 /* { dg-options "-march=armv6-m -mthumb" } */
 
 #ifdef __ARM_NEON_FP
Index: gcc/testsuite/gcc.target/arm/thumb-bitfld1.c
===================================================================
--- gcc/testsuite/gcc.target/arm/thumb-bitfld1.c	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ gcc/testsuite/gcc.target/arm/thumb-bitfld1.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -10,6 +10,8 @@
   unsigned b28 : 1;
   unsigned rest : 28;
 };
+
+unsigned
 foo(a)
      struct foo a;
 {
Index: gcc/testsuite/gcc.target/arm/split-live-ranges-for-shrink-wrap.c
===================================================================
--- gcc/testsuite/gcc.target/arm/split-live-ranges-for-shrink-wrap.c	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ gcc/testsuite/gcc.target/arm/split-live-ranges-for-shrink-wrap.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -1,6 +1,8 @@
 /* { dg-do assemble } */
 /* { dg-options "-mthumb -Os -fdump-rtl-ira " }  */
 /* { dg-require-effective-target arm_thumb1_ok } */
+/* { dg-skip-if "do not test on armv4t" { *-*-* } { "-march=armv4t" } } */
+/* { dg-additional-options "-march=armv5t" {target arm_arch_v5t_ok} } */
 
 int foo (char *, char *, int);
 int test (int d, char * out, char *in, int len)
Index: gcc/testsuite/gcc.target/arm/armv8-sync-op-release.c
===================================================================
--- gcc/testsuite/gcc.target/arm/armv8-sync-op-release.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/arm/armv8-sync-op-release.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,8 @@
+/* { dg-do compile } */
+/* { dg-require-effective-target arm_arch_v8a_ok } */
+/* { dg-options "-O2" } */
+/* { dg-add-options arm_arch_v8a } */
+
+#include "../aarch64/sync-op-release.x"
+
+/* { dg-final { scan-assembler-times "stl" 1 } } */
Index: gcc/testsuite/gcc.target/arm/pr63210.c
===================================================================
--- gcc/testsuite/gcc.target/arm/pr63210.c	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ gcc/testsuite/gcc.target/arm/pr63210.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -1,6 +1,8 @@
 /* { dg-do assemble } */
 /* { dg-options "-mthumb -Os " }  */
 /* { dg-require-effective-target arm_thumb1_ok } */
+/* { dg-skip-if "do not test on armv4t" { *-*-* } { "-march=armv4t" } } */
+/* { dg-additional-options "-march=armv5t" {target arm_arch_v5t_ok} } */
 
 int foo1 (int c);
 int foo2 (int c);
Index: gcc/testsuite/gcc.target/aarch64/sync-op-release.c
===================================================================
--- gcc/testsuite/gcc.target/aarch64/sync-op-release.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/aarch64/sync-op-release.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,6 @@
+/* { dg-do compile } */
+/* { dg-options "-O2" } */
+
+#include "sync-op-release.x"
+
+/* { dg-final { scan-assembler-times "stlr" 1 } } */
Index: gcc/testsuite/gcc.target/aarch64/sync-op-release.x
===================================================================
--- gcc/testsuite/gcc.target/aarch64/sync-op-release.x	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/aarch64/sync-op-release.x	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,7 @@
+int v;
+
+void
+sync_lock_release (void)
+{
+  __sync_lock_release (&v);
+}
Index: gcc/testsuite/gcc.target/aarch64/fnmul-1.c
===================================================================
--- gcc/testsuite/gcc.target/aarch64/fnmul-1.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/aarch64/fnmul-1.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,16 @@
+/* { dg-do compile } */
+/* { dg-options "-O2" } */
+
+double
+foo_d (double a, double b)
+{
+  /* { dg-final { scan-assembler "fnmul\\td\[0-9\]+, d\[0-9\]+, d\[0-9\]+" } } */
+  return -a * b;
+}
+
+float
+foo_s (float a, float b)
+{
+  /* { dg-final { scan-assembler "fnmul\\ts\[0-9\]+, s\[0-9\]+, s\[0-9\]+" } } */
+  return -a * b;
+}
Index: gcc/testsuite/gcc.target/aarch64/sync-op-acquire.c
===================================================================
--- gcc/testsuite/gcc.target/aarch64/sync-op-acquire.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/aarch64/sync-op-acquire.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,8 @@
+/* { dg-do compile } */
+/* { dg-options "-O2" } */
+
+#include "sync-op-acquire.x"
+
+/* { dg-final { scan-assembler-times "ldxr\tw\[0-9\]+, \\\[x\[0-9\]+\\\]" 1 } } */
+/* { dg-final { scan-assembler-times "stxr\tw\[0-9\]+, w\[0-9\]+, \\\[x\[0-9\]+\\\]" 1 } } */
+/* { dg-final { scan-assembler-times "dmb\tish" 1 } } */
Index: gcc/testsuite/gcc.target/aarch64/sync-op-acquire.x
===================================================================
--- gcc/testsuite/gcc.target/aarch64/sync-op-acquire.x	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/aarch64/sync-op-acquire.x	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,7 @@
+int v;
+
+int
+sync_lock_test_and_set (int a)
+{
+  return __sync_lock_test_and_set (&v, a);
+}
Index: gcc/testsuite/gcc.target/aarch64/fnmul-2.c
===================================================================
--- gcc/testsuite/gcc.target/aarch64/fnmul-2.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/aarch64/fnmul-2.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,18 @@
+/* { dg-do compile } */
+/* { dg-options "-O2 -frounding-math" } */
+
+double
+foo_d (double a, double b)
+{
+  /* { dg-final { scan-assembler "fneg\\td\[0-9\]+, d\[0-9\]+" } } */
+  /* { dg-final { scan-assembler "fmul\\td\[0-9\]+, d\[0-9\]+, d\[0-9\]+" } } */
+  return -a * b;
+}
+
+float
+foo_s (float a, float b)
+{
+  /* { dg-final { scan-assembler "fneg\\ts\[0-9\]+, s\[0-9\]+" } } */
+  /* { dg-final { scan-assembler "fmul\\ts\[0-9\]+, s\[0-9\]+, s\[0-9\]+" } } */
+  return -a * b;
+}
Index: gcc/testsuite/gcc.target/aarch64/sync-comp-swap.c
===================================================================
--- gcc/testsuite/gcc.target/aarch64/sync-comp-swap.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/aarch64/sync-comp-swap.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,8 @@
+/* { dg-do compile } */
+/* { dg-options "-O2 -fno-ipa-icf" } */
+
+#include "sync-comp-swap.x"
+
+/* { dg-final { scan-assembler-times "ldxr\tw\[0-9\]+, \\\[x\[0-9\]+\\\]" 2 } } */
+/* { dg-final { scan-assembler-times "stlxr\tw\[0-9\]+, w\[0-9\]+, \\\[x\[0-9\]+\\\]" 2 } } */
+/* { dg-final { scan-assembler-times "dmb\tish" 2 } } */
Index: gcc/testsuite/gcc.target/aarch64/sync-op-full.c
===================================================================
--- gcc/testsuite/gcc.target/aarch64/sync-op-full.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/aarch64/sync-op-full.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,8 @@
+/* { dg-do compile } */
+/* { dg-options "-O2" } */
+
+#include "sync-op-full.x"
+
+/* { dg-final { scan-assembler-times "ldxr\tw\[0-9\]+, \\\[x\[0-9\]+\\\]" 12 } } */
+/* { dg-final { scan-assembler-times "stlxr\tw\[0-9\]+, w\[0-9\]+, \\\[x\[0-9\]+\\\]" 12 } } */
+/* { dg-final { scan-assembler-times "dmb\tish" 12 } } */
Index: gcc/testsuite/gcc.target/aarch64/sync-comp-swap.x
===================================================================
--- gcc/testsuite/gcc.target/aarch64/sync-comp-swap.x	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/aarch64/sync-comp-swap.x	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,13 @@
+int v = 0;
+
+int
+sync_bool_compare_swap (int a, int b)
+{
+  return __sync_bool_compare_and_swap (&v, &a, &b);
+}
+
+int
+sync_val_compare_swap (int a, int b)
+{
+  return __sync_val_compare_and_swap (&v, &a, &b);
+}
Index: gcc/testsuite/gcc.target/aarch64/sync-op-full.x
===================================================================
--- gcc/testsuite/gcc.target/aarch64/sync-op-full.x	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/aarch64/sync-op-full.x	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,73 @@
+int v = 0;
+
+int
+sync_fetch_and_add (int a)
+{
+  return __sync_fetch_and_add (&v, a);
+}
+
+int
+sync_fetch_and_sub (int a)
+{
+  return __sync_fetch_and_sub (&v, a);
+}
+
+int
+sync_fetch_and_and (int a)
+{
+  return __sync_fetch_and_and (&v, a);
+}
+
+int
+sync_fetch_and_nand (int a)
+{
+  return __sync_fetch_and_nand (&v, a);
+}
+
+int
+sync_fetch_and_xor (int a)
+{
+  return __sync_fetch_and_xor (&v, a);
+}
+
+int
+sync_fetch_and_or (int a)
+{
+  return __sync_fetch_and_or (&v, a);
+}
+
+int
+sync_add_and_fetch (int a)
+{
+  return __sync_add_and_fetch (&v, a);
+}
+
+int
+sync_sub_and_fetch (int a)
+{
+  return __sync_sub_and_fetch (&v, a);
+}
+
+int
+sync_and_and_fetch (int a)
+{
+  return __sync_and_and_fetch (&v, a);
+}
+
+int
+sync_nand_and_fetch (int a)
+{
+  return __sync_nand_and_fetch (&v, a);
+}
+
+int
+sync_xor_and_fetch (int a)
+{
+  return __sync_xor_and_fetch (&v, a);
+}
+
+int
+sync_or_and_fetch (int a)
+{
+  return __sync_or_and_fetch (&v, a);
+}
Index: gcc/testsuite/gcc.target/aarch64/fnmul-3.c
===================================================================
--- gcc/testsuite/gcc.target/aarch64/fnmul-3.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/aarch64/fnmul-3.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,16 @@
+/* { dg-do compile } */
+/* { dg-options "-O2" } */
+
+double
+foo_d (double a, double b)
+{
+  /* { dg-final { scan-assembler "fnmul\\td\[0-9\]+, d\[0-9\]+, d\[0-9\]+" } } */
+  return -(a * b);
+}
+
+float
+foo_s (float a, float b)
+{
+  /* { dg-final { scan-assembler "fnmul\\ts\[0-9\]+, s\[0-9\]+, s\[0-9\]+" } } */
+  return -(a * b);
+}
Index: gcc/testsuite/gcc.target/aarch64/fnmul-4.c
===================================================================
--- gcc/testsuite/gcc.target/aarch64/fnmul-4.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/aarch64/fnmul-4.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,16 @@
+/* { dg-do compile } */
+/* { dg-options "-O2 -frounding-math" } */
+
+double
+foo_d (double a, double b)
+{
+  /* { dg-final { scan-assembler "fnmul\\td\[0-9\]+, d\[0-9\]+, d\[0-9\]+" } } */
+  return -(a * b);
+}
+
+float
+foo_s (float a, float b)
+{
+  /* { dg-final { scan-assembler "fnmul\\ts\[0-9\]+, s\[0-9\]+, s\[0-9\]+" } } */
+  return -(a * b);
+}
Index: gcc/testsuite/gcc.target/i386/adx-addcarryx64-1.c
===================================================================
--- gcc/testsuite/gcc.target/i386/adx-addcarryx64-1.c	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ gcc/testsuite/gcc.target/i386/adx-addcarryx64-1.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -1,6 +1,6 @@
 /* { dg-do compile { target { ! ia32 } } } */
 /* { dg-options "-madx -O2" } */
-/* { dg-final { scan-assembler-times "adcx" 2 } } */
+/* { dg-final { scan-assembler-times "adc\[xq\]" 2 } } */
 /* { dg-final { scan-assembler-times "sbbq" 1 } } */
 
 #include <x86intrin.h>
Index: gcc/testsuite/gcc.target/i386/pr66648.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr66648.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/i386/pr66648.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,33 @@
+/* { dg-do run } */
+/* { dg-options "-O2 -mstringop-strategy=unrolled_loop -mtune=nocona" } */
+
+#define PATTERN 0xdeadbeef
+#define SIZE    32
+
+struct S { int i; char str[SIZE]; int j; };
+
+void __attribute__((noclone, noinline))
+my_memcpy (char *, const char *, unsigned int);
+
+void
+my_memcpy (char *dst, const char *src, unsigned int len)
+{
+  if (len < 8)
+    __builtin_abort ();
+
+  __builtin_memcpy (dst, src, len);
+}
+
+int
+main (void)
+{
+  const char str[SIZE]= "1234567890123456789012345678901";
+  struct S *s = __builtin_malloc (sizeof (struct S));
+
+  s->j = PATTERN;
+  my_memcpy (s->str, str, SIZE);
+  if (s->j != PATTERN)
+    __builtin_abort ();
+
+  return 0;
+}
Index: gcc/testsuite/gcc.target/i386/pr66691.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr66691.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/i386/pr66691.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,64 @@
+/* PR debug/66691 */
+/* { dg-do compile } */
+/* { dg-require-effective-target ia32 } */
+/* { dg-options "-O3 -g -mtune=generic -march=i686" } */
+
+unsigned int a;
+int b[2], c, d, e, f, g, h, i, k[8], l, m, s, t, w;
+static int j;
+
+void
+fn1 (long long p)
+{
+  int t = p;
+  c = c ^ b[c ^ (t & 1)];
+}
+
+static void
+fn2 (long long p)
+{
+  c = c ^ b[1 ^ (d & 1)];
+  fn1 (p >> 1 & 1);
+  fn1 (p >> 2);
+}
+
+static void
+fn3 ()
+{
+  unsigned char p;
+  f = g = 0;
+  for (h = 0; h < 6; h++)
+    {
+      for (s = 0; s < 7; s++)
+	if (k[s+1])
+	  g = 0;
+	else
+	  for (j = 0; j < 2; j++)
+	    ;
+      t = j > 2 ? 0 : 1 >> j;
+    }
+  if (l)
+    {
+      short q[2];
+      q[0] = q[1] = 0;
+      if (m)
+	for (i = 0; i < 2; i++)
+	  {
+	    unsigned char r = q[i];
+	    p = f ? r % f : r;
+	    e = ((p > 0) <= (q[i] ^ 1)) + a;
+	    if (k[1])
+	      for (e = 0; e != 18; ++e)
+		k[0] = 0;
+	  }
+    }
+}
+
+int
+main ()
+{
+  fn3 ();
+  fn2 (w);
+  fn2 (j);
+  return 0;
+}
Index: gcc/testsuite/gcc.target/i386/pr66838.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr66838.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/i386/pr66838.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,36 @@
+/* { dg-do run { target lp64 } } */
+/* { dg-options "-O2" } */
+
+void abort (void);
+
+char global;
+
+__attribute__((sysv_abi, noinline, noclone))
+void sysv_abi_func(char const *desc, void *local)
+{
+  register int esi asm ("esi");
+  register int edi asm ("edi");
+  
+  if (local != &global)
+    abort ();
+
+  /* Clobber some of the extra SYSV ABI registers.  */
+  asm volatile ("movl\t%2, %0\n\tmovl\t%2, %1"
+		: "=r" (esi), "=r" (edi)
+		: "i" (0xdeadbeef));
+}
+
+__attribute__((ms_abi, noinline, noclone))
+void ms_abi_func ()
+{
+  sysv_abi_func ("1st call", &global);
+  sysv_abi_func ("2nd call", &global);
+  sysv_abi_func ("3rd call", &global);
+}
+
+int
+main(void)
+{
+  ms_abi_func();
+  return 0;
+}
Index: gcc/testsuite/gcc.target/i386/pr67317-1.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr67317-1.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/i386/pr67317-1.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,18 @@
+/* PR target/67317 */
+/* { dg-do compile } */
+/* { dg-options "-O2" } */
+
+typedef unsigned int u32;
+
+u32 testcarry_u32 (u32 a, u32 b, u32 c, u32 d)
+{
+  u32 result0, result1;
+
+  __builtin_ia32_addcarryx_u32
+    (__builtin_ia32_addcarryx_u32 (0, a, c, &result0), b, d, &result1);
+
+  return result0 ^ result1;
+}
+
+/* { dg-final { scan-assembler-not "addb" } } */
+/* { dg-final { scan-assembler-not "setn?c" } } */
Index: gcc/testsuite/gcc.target/i386/pr67317-2.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr67317-2.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/i386/pr67317-2.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,18 @@
+/* PR target/67317 */
+/* { dg-do compile { target { ! ia32 } } } */
+/* { dg-options "-O2" } */
+
+typedef unsigned long long u64;
+
+u64 testcarry_u64 (u64 a, u64 b, u64 c, u64 d)
+{
+  u64 result0, result1;
+
+  __builtin_ia32_addcarryx_u64
+    (__builtin_ia32_addcarryx_u64 (0, a, c, &result0), b, d, &result1);
+
+  return result0 ^ result1;
+}
+
+/* { dg-final { scan-assembler-not "addb" } } */
+/* { dg-final { scan-assembler-not "setn?c" } } */
Index: gcc/testsuite/gcc.target/i386/pr67317-3.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr67317-3.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/i386/pr67317-3.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,18 @@
+/* PR target/67317 */
+/* { dg-do compile } */
+/* { dg-options "-O2" } */
+
+typedef unsigned int u32;
+
+u32 testcarry_u32 (u32 a, u32 b, u32 c, u32 d)
+{
+  u32 result0, result1;
+
+  __builtin_ia32_sbb_u32
+    (__builtin_ia32_sbb_u32 (0, a, c, &result0), b, d, &result1);
+
+  return result0 ^ result1;
+}
+
+/* { dg-final { scan-assembler-not "addb" } } */
+/* { dg-final { scan-assembler-not "setn?c" } } */
Index: gcc/testsuite/gcc.target/i386/readeflags-1.c
===================================================================
--- gcc/testsuite/gcc.target/i386/readeflags-1.c	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ gcc/testsuite/gcc.target/i386/readeflags-1.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -9,10 +9,11 @@
 #define EFLAGS_TYPE unsigned int
 #endif
 
-static EFLAGS_TYPE
+__attribute__((noinline, noclone))
+EFLAGS_TYPE
 readeflags_test (unsigned int a, unsigned int b)
 {
-  unsigned x = (a == b);
+  volatile char x = (a == b);
   return __readeflags ();
 }
 
Index: gcc/testsuite/gcc.target/i386/pr66891.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr66891.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/i386/pr66891.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,16 @@
+/* { dg-do compile { target ia32 } } */
+/* { dg-options "-O2" } */
+
+__attribute__((__stdcall__)) void fn1();
+
+int a;
+
+static void fn2() {
+  for (;;)
+    ;
+}
+
+void fn3() {
+  fn1(0);
+  fn2(a == 0);
+}
Index: gcc/testsuite/gcc.target/i386/pr66703.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr66703.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/i386/pr66703.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,4 @@
+/* { dg-do run { target { ia32 } } } */
+/* { dg-options "-O0 -mtune=pentium" } */
+
+#include "readeflags-1.c"
Index: gcc/testsuite/gcc.target/i386/pr67317-4.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr67317-4.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/i386/pr67317-4.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,18 @@
+/* PR target/67317 */
+/* { dg-do compile { target { ! ia32 } } } */
+/* { dg-options "-O2" } */
+
+typedef unsigned long long u64;
+
+u64 testcarry_u64 (u64 a, u64 b, u64 c, u64 d)
+{
+  u64 result0, result1;
+
+  __builtin_ia32_sbb_u64
+    (__builtin_ia32_sbb_u64 (0, a, c, &result0), b, d, &result1);
+
+  return result0 ^ result1;
+}
+
+/* { dg-final { scan-assembler-not "addb" } } */
+/* { dg-final { scan-assembler-not "setn?c" } } */
Index: gcc/testsuite/gcc.target/i386/adx-addcarryx32-1.c
===================================================================
--- gcc/testsuite/gcc.target/i386/adx-addcarryx32-1.c	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ gcc/testsuite/gcc.target/i386/adx-addcarryx32-1.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -1,6 +1,6 @@
 /* { dg-do compile } */
 /* { dg-options "-madx -O2" } */
-/* { dg-final { scan-assembler-times "adcx" 2 } } */
+/* { dg-final { scan-assembler-times "adc\[xl\]" 2 } } */
 /* { dg-final { scan-assembler-times "sbbl" 1 } } */
 
 #include <x86intrin.h>
Index: gcc/testsuite/gcc.target/i386/pr66922.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr66922.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/i386/pr66922.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,23 @@
+/* { dg-do run } */
+/* { dg-options "-O1 -msse2" } */
+/* { dg-require-effective-target sse2 } */
+
+#include "sse2-check.h"
+
+struct S 
+{
+  int:31;
+  int:2;
+  int f0:16;
+  int f1;
+  int f2;
+};
+
+static void 
+sse2_test (void)
+{
+  struct S a = { 1, 0, 0 };
+
+  if (a.f0 != 1)
+    __builtin_abort(); 
+}
Index: gcc/testsuite/gcc.target/i386/pr66814.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr66814.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/i386/pr66814.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,4 @@
+/* { dg-do compile { target { ia32 } } } */
+/* { dg-options "-march=i586 -mavx512f -O2" } */
+
+#include "avx512f-klogic-2.c"
Index: gcc/testsuite/gcc.target/i386/mpx/pr66566.c
===================================================================
--- gcc/testsuite/gcc.target/i386/mpx/pr66566.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/i386/mpx/pr66566.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,12 @@
+/* { dg-do compile } */
+/* { dg-options "-O2 -fcheck-pointer-bounds -mmpx" } */
+
+union jsval_layout
+{
+  void *asPtr;
+};
+union jsval_layout a;
+union jsval_layout b;
+union jsval_layout __inline__ fn1() { return b; }
+
+void fn2() { a = fn1(); }
Index: gcc/testsuite/gcc.target/i386/mpx/pr66567.c
===================================================================
--- gcc/testsuite/gcc.target/i386/mpx/pr66567.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/i386/mpx/pr66567.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,16 @@
+/* { dg-do compile } */
+/* { dg-options "-fcheck-pointer-bounds -mmpx" } */
+
+void  (*b) ();
+
+void fn1 (const int *p1)
+{
+  static void *a = &&conv_1234_123C;
+ conv_1234_123C:
+  ;
+}
+
+void fn2 ()
+{
+  b = fn1;
+}
Index: gcc/testsuite/gcc.target/i386/mpx/pr66134.c
===================================================================
--- gcc/testsuite/gcc.target/i386/mpx/pr66134.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/i386/mpx/pr66134.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,17 @@
+/* { dg-do compile } */
+/* { dg-options "-O2 -fcheck-pointer-bounds -mmpx -fno-tree-ccp" } */
+
+extern int vfork (void) __attribute__ ((__nothrow__ , __leaf__));
+void test1 (void);
+void test2 (void);
+void test3 (int *);
+
+void test (int *p)
+{
+ test1 ();
+ p++;
+ test2 ();
+ p++;
+ vfork ();
+ test3 (p);
+}
Index: gcc/testsuite/gcc.target/i386/mpx/pr66568.c
===================================================================
--- gcc/testsuite/gcc.target/i386/mpx/pr66568.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/i386/mpx/pr66568.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,11 @@
+/* { dg-do compile } */
+/* { dg-require-effective-target fpic } */
+/* { dg-options "-O2 -fcheck-pointer-bounds -mmpx -O2 -fPIC" } */
+
+extern void exit (int);
+int a, b, c;
+void *set_test () {
+  if (b)
+    a ? exit (0) : exit (1);
+  b = c;
+}
Index: gcc/testsuite/gcc.target/i386/mpx/pr66569.c
===================================================================
--- gcc/testsuite/gcc.target/i386/mpx/pr66569.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/i386/mpx/pr66569.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,14 @@
+/* { dg-do compile } */
+/* { dg-options "-fcheck-pointer-bounds -mmpx" } */
+
+struct s1 {
+  int *p;
+  int i;
+};
+
+struct s2 {
+  struct s1 s;
+  int i;
+};
+
+int test (struct s2 s, ...) { }
Index: gcc/testsuite/gcc.target/i386/mpx/pr66048.cc
===================================================================
--- gcc/testsuite/gcc.target/i386/mpx/pr66048.cc	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/i386/mpx/pr66048.cc	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,16 @@
+/* { dg-do compile } */
+/* { dg-options "-O2 -fcheck-pointer-bounds -mmpx -march=corei7-avx" } */
+
+struct c1
+{
+  c1 (const c1 &other) : p (other.p) { };
+  int *p;
+};
+
+struct c2 : public c1 { };
+
+c1
+test (c2 a)
+{
+  return a;
+}
Index: gcc/testsuite/gcc.target/i386/mpx/pr66581.c
===================================================================
--- gcc/testsuite/gcc.target/i386/mpx/pr66581.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/i386/mpx/pr66581.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,18 @@
+/* { dg-do compile } */
+/* { dg-options "-fcheck-pointer-bounds -mmpx" } */
+
+void *a;
+int b;
+
+void
+fn1 (void)
+{
+  void *c = &&l_nop;
+l_nop:
+    for (; b;)
+    ;
+  int *d = c;
+  c = fn1;
+  *d = 1;
+  goto *a;
+}
Index: gcc/testsuite/gcc.target/s390/zvector/vec-load_bndry-1.c
===================================================================
--- gcc/testsuite/gcc.target/s390/zvector/vec-load_bndry-1.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.target/s390/zvector/vec-load_bndry-1.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,80 @@
+/* { dg-do compile { target { s390*-*-* } } } */
+/* { dg-options "-O0 -mzarch -march=z13 -mzvector" } */
+
+#include <vecintrin.h>
+
+signed char
+foo64 (signed char *p)
+{
+  return vec_load_bndry (p, 64)[0];
+  /* { dg-final { scan-assembler-times "\tvlbb\t%v..?,0\\(%r..?\\),0" 1 } } */
+}
+
+signed char
+foo128 (signed char *p)
+{
+  return
+    vec_load_bndry (p, 128)[0]
+    + vec_load_bndry (p + 16, 128)[0];
+  /* { dg-final { scan-assembler-times "\tvlbb\t%v..?,0\\(%r..?\\),1" 2 } } */
+}
+
+signed char
+foo256 (signed char *p)
+{
+  return
+    vec_load_bndry (p, 256)[0]
+    + vec_load_bndry (p + 16, 256)[0]
+    + vec_load_bndry (p + 32, 256)[0];
+  /* { dg-final { scan-assembler-times "\tvlbb\t%v..?,0\\(%r..?\\),2" 3 } } */
+}
+
+signed char
+foo512 (signed char *p)
+{
+  return
+    vec_load_bndry (p, 512)[0]
+    + vec_load_bndry (p + 16, 512)[0]
+    + vec_load_bndry (p + 32, 512)[0]
+    + vec_load_bndry (p + 48, 512)[0];
+  /* { dg-final { scan-assembler-times "\tvlbb\t%v..?,0\\(%r..?\\),3" 4 } } */
+}
+
+signed char
+foo1024 (signed char *p)
+{
+  return
+    vec_load_bndry (p, 1024)[0]
+    + vec_load_bndry (p + 16, 1024)[0]
+    + vec_load_bndry (p + 32, 1024)[0]
+    + vec_load_bndry (p + 48, 1024)[0]
+    + vec_load_bndry (p + 64, 1024)[0];
+  /* { dg-final { scan-assembler-times "\tvlbb\t%v..?,0\\(%r..?\\),4" 5 } } */
+}
+
+signed char
+foo2048 (signed char *p)
+{
+  return
+    vec_load_bndry (p, 2048)[0]
+    + vec_load_bndry (p + 16, 2048)[0]
+    + vec_load_bndry (p + 32, 2048)[0]
+    + vec_load_bndry (p + 48, 2048)[0]
+    + vec_load_bndry (p + 64, 2048)[0]
+    + vec_load_bndry (p + 80, 2048)[0];
+  /* { dg-final { scan-assembler-times "\tvlbb\t%v..?,0\\(%r..?\\),5" 6 } } */
+}
+
+signed char
+foo4096 (signed char *p)
+{
+  return
+    vec_load_bndry (p, 4096)[0]
+    + vec_load_bndry (p + 16, 4096)[0]
+    + vec_load_bndry (p + 32, 4096)[0]
+    + vec_load_bndry (p + 48, 4096)[0]
+    + vec_load_bndry (p + 64, 4096)[0]
+    + vec_load_bndry (p + 80, 4096)[0]
+    + vec_load_bndry (p + 96, 4096)[0];
+  /* { dg-final { scan-assembler-times "\tvlbb\t%v..?,0\\(%r..?\\),6" 7 } } */
+}
Index: gcc/testsuite/gfortran.dg/pr67526.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr67526.f90	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gfortran.dg/pr67526.f90	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,9 @@
+! { dg-do compile }
+! Original code from gerhard dot steinmetz dot fortran at t-online dot de
+! PR fortran/67526
+program p
+   character :: c1 = 'abc'(:     ! { dg-error "error in SUBSTRING" }
+   character :: c2 = 'abc'(3:    ! { dg-error "error in SUBSTRING" }
+   character :: c3 = 'abc'(:1    ! { dg-error "error in SUBSTRING" }
+   character :: c4 = 'abc'(2:2   ! { dg-error "error in SUBSTRING" }
+end
Index: gcc/testsuite/gfortran.dg/pr66864.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr66864.f90	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/gfortran.dg/pr66864.f90	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,16 @@
+! { dg-do run }
+! PR fortran/66864
+!
+program t
+   implicit none
+   real(8) x
+   x = 2.0d0**26.5d0
+   if (floor(x) /= 94906265) call abort
+   if (floor(2.0d0**26.5d0)/= 94906265) call abort
+   x = 777666555.6d0
+   if (floor(x) /= 777666555) call abort
+   if (floor(777666555.6d0) /= 777666555) call abort
+   x = 2000111222.6d0
+   if (floor(x) /= 2000111222) call abort
+   if (floor(2000111222.6d0) /= 2000111222) call abort
+end program t
